!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine BasicType
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: basictype.f90,v 1.2 2005/01/28 12:41:21 sugiyama Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!ŵŪʴܾ׻뤿Υ֥롼. 
!פȤƤϰʲǽ. 
!   * ٰ or ̰
!   * ϰ or ſ尵ʿ
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
                                                                 !=end

subroutine BasicType(ss_CpBasicZ, ss_DensBasicZ, &
     & ss_ExnerBasicZ, ss_PotTempBasicZ, ss_VelSoundBasicZ)
                                                                 !=begin
  !== Dependency
  use gridset, only:  DimXMin, DimXMax, DimZMin, DimZMax, s_Z
  use physprm, only:  GasRUniv
  use basicprm, only: Grav, TempSfc, PressSfc, MolWtDry, CpDry, &
       &               TempType, PressType
                                                                 !=end

  !--- ۤηػ
  implicit none
                                                                 !=begin
  !== Output
  real(8), intent(out) :: ss_CpBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)      !Ǯ
  real(8), intent(out) :: ss_DensBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)    !̩
  real(8), intent(out) :: ss_ExnerBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)   !̵
  real(8), intent(out) :: ss_PotTempBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)   !
  real(8), intent(out) :: ss_VelSoundBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)!®
                                                                 !=end
  !--- ѿ
  real(8)  :: ss_TempBasicZ(DimXMin:DimXMax, DimZMin:DimZMax) ! ʿѲپ
  real(8)  :: ss_CvBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)  :: ss_Z(DimXMin:DimXMax, DimZMin:DimZMax)     ! 2-D ɸ
  real(8)  :: GasR
  integer  :: k


  !--- ɸ
  do k = DimZMin, DimZMax
     ss_Z(:,k) = s_Z(k)
  end do

  !--------------------------------------------
  !--- 
  !--------------------------------------------
  GasR = GasRUniv / MolWtDry
  
  
  !--------------------------------------------
  !--- Ǯ
  !---   Ǯϴ絤ǰƬ˰ͤȤ. 
  !--------------------------------------------
  ss_CpBasicZ = CpDry / MolWtDry
  ss_CvBasicZ = ss_CpBasicZ - GasR


  !--------------------------------------------
  !--- /, ̵Ϥδܾ
  !--------------------------------------------
  if (TempType == "uniform" .AND. PressType == "uniform") then 

     !--- پ TempSfc ǰ
     ss_TempBasicZ = TempSfc
     
     !--- ɽ̰Ϥǰ. ͤ 1 Ȥʤ. 
     ss_ExnerBasicZ = 1.0d0
     
     !--- 
     ss_PotTempBasicZ = ss_TempBasicZ / ss_ExnerBasicZ 
     
  elseif (TempType == "uniform" .AND. PressType == "hydrostatic") then 
     
     !--- پ TempSfc ǰ
     ss_TempBasicZ = TempSfc
     
     !--- ̵ϤȲ̤ϢΩƲ. 
     ss_ExnerBasicZ = &
          & dexp( - Grav * ss_Z / ( ss_CpBasicZ * ss_TempBasicZ ) )

     !--- ̵ϤѤƲ̤׻
     ss_PotTempBasicZ = ss_TempBasicZ / ss_ExnerBasicZ
     
  elseif (TempType == "adiabat" .AND. PressType == "uniform") then 

     !--- ɽ̤Ǥβ(= TempSfc)ǰ
     ss_PotTempBasicZ = TempSfc

     !--- ɽ̰Ϥǰ. ͤ 1 Ȥʤ. 
     ss_ExnerBasicZ = 1.0d0

  elseif (TempType == "adiabat" .AND. PressType == "hydrostatic") then 
     
     !--- ɽ̤Ǥβ(= TempSfc)ǰ
     ss_PotTempBasicZ = TempSfc

     !--- ̵Ϥ׻. ̰
     ss_ExnerBasicZ = &
          & - Grav * ss_Z / ( ss_CpBasicZ * ss_PotTempBasicZ ) + 1.0d0

  else
     write(*,*) "unknown TempType, or PressType"
     write(*,*) TempType, PressType
        
  end if

    
  !--------------------------------------------
  !---- ̩
  !--------------------------------------------
  ss_DensBasicZ = &
       & PressSfc * ( ss_ExnerBasicZ ** (ss_CvBasicZ / GasR) ) &
       &   / ( GasR * ss_PotTempBasicZ )
  
  
  !--------------------------------------------    
  !--- ʿѾβ®
  !--------------------------------------------
  ss_VelSoundBasicZ = &
       & ss_CpBasicZ * GasR * ss_ExnerBasicZ * ss_PotTempBasicZ &
       &   / ss_CvBasicZ  
  ss_VelSoundBasicZ = sqrt( ss_VelSoundBasicZ )
  
  
end subroutine BasicType

